"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var path = require("path");
var index_1 = require("./index");
var BUILD_ENV_RECURSION_STOP_FILE_NAME = ".build-env-root";
var logs = {
    envNotFound: function (envPath) {
        return "[build-env] env not found at '".concat(envPath, "'");
    },
    envFound: function (envPath) {
        return "[build-env] found env at '".concat(envPath, "'");
    },
    envLoadingError: function (envPath) {
        return "[build-env] error loading env at '".concat(envPath, "'");
    },
    envRecursionStopped: function (startDir, curDir, envRecursionStopPath) {
        return "[build-env] Couldn't load env from '".concat(startDir, "' to '").concat(curDir, "'. Stopped at '").concat(envRecursionStopPath, "'");
    },
    cantNegateNonBoolean: function (envPropertyValue) {
        return "[build-env] Cannot negate non-boolean value '".concat(envPropertyValue, "'");
    },
    cantReturnNonString: function (propertyPath, propertyType) {
        return "[build-env] Env property '".concat(propertyPath, "' is not of type \"string\", \"number\", or \"boolean\". Found \"").concat(propertyType, "\":");
    },
    pleaseProvideEnvPropertyPath: function () {
        return "[build-env] Please provide an env property path.";
    },
    seeAllEnvProperties: function () {
        return "[build-env] See all env properties with 'build-env --print-env'";
    },
    propertyNotFound: function (propertyPath) {
        return "[build-env] Env property '".concat(propertyPath, "' not found.");
    },
};
function requireEnv(curDir) {
    return __awaiter(this, void 0, void 0, function () {
        var envPathJS, envPathCJS, envPathJSExist, envPathCJSExist, envPath, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    envPathJS = path.resolve(curDir, "env", "index.js");
                    envPathCJS = path.resolve(curDir, "env", "index.cjs");
                    envPathJSExist = fs.existsSync(envPathJS);
                    envPathCJSExist = fs.existsSync(envPathCJS);
                    envPath = envPathJSExist ? envPathJS : envPathCJS;
                    if (!envPathJSExist && !envPathCJSExist) {
                        return [2, undefined];
                    }
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4, Promise.resolve().then(function () { return require(envPath); })];
                case 2: return [2, (_a.sent())];
                case 3:
                    e_1 = _a.sent();
                    console.info(logs.envLoadingError(envPath));
                    throw e_1;
                case 4: return [2];
            }
        });
    });
}
function findEnv(startDir, curDir) {
    return __awaiter(this, void 0, void 0, function () {
        var env, envRecursionStopPath;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, requireEnv(curDir)];
                case 1:
                    env = _a.sent();
                    if (env) {
                        return [2, env];
                    }
                    envRecursionStopPath = path.resolve(curDir, BUILD_ENV_RECURSION_STOP_FILE_NAME);
                    if (fs.existsSync(envRecursionStopPath)) {
                        console.info(logs.envRecursionStopped(startDir, curDir, envRecursionStopPath));
                        process.exit(1);
                    }
                    return [2, findEnv(startDir, path.dirname(curDir))];
            }
        });
    });
}
function parseVars(vars) {
    var result = {};
    for (var v in vars) {
        result[v] = (0, index_1.treatVarToPrint)(vars[v]);
    }
    return result;
}
function main() {
    return __awaiter(this, void 0, void 0, function () {
        var _a, env, vars, self, opt, flags, flattenedParsedVars, envFile, _b, _c, key, flattenedParsedVars, envFile, _d, _e, key, propertyPath, envPropertyValue, _f, _g, p, isBoolean;
        var e_2, _h, e_3, _j, e_4, _k;
        return __generator(this, function (_l) {
            switch (_l.label) {
                case 0: return [4, findEnv(path.resolve("."), path.resolve("."))];
                case 1:
                    _a = _l.sent(), env = _a.env, vars = _a.vars, self = _a.self;
                    opt = process.argv[2];
                    flags = process.argv[3];
                    if (opt === "--print-vars") {
                        console.log(JSON.stringify(flattenObj(parseVars(vars)), undefined, 2));
                        process.exit(0);
                    }
                    if (opt === "--print-env") {
                        console.log(JSON.stringify(flattenObj(env), undefined, 2));
                        process.exit(0);
                    }
                    if (opt === "--print-env-file") {
                        flattenedParsedVars = flattenObj(parseVars(vars));
                        envFile = "";
                        try {
                            for (_b = __values(Object.keys(flattenedParsedVars)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                key = _c.value;
                                envFile += "".concat(key, "=").concat(flattenedParsedVars[key], "\n");
                            }
                        }
                        catch (e_2_1) { e_2 = { error: e_2_1 }; }
                        finally {
                            try {
                                if (_c && !_c.done && (_h = _b.return)) _h.call(_b);
                            }
                            finally { if (e_2) throw e_2.error; }
                        }
                        console.log(envFile);
                        process.exit(0);
                    }
                    if (opt === "--print-vars:self") {
                        console.log(JSON.stringify(flattenObj(parseVars(self.vars)), undefined, 2));
                        process.exit(0);
                    }
                    if (opt === "--print-env:self") {
                        console.log(JSON.stringify(flattenObj(self.env), undefined, 2));
                        process.exit(0);
                    }
                    if (opt === "--print-env-file:self") {
                        flattenedParsedVars = flattenObj(parseVars(self.vars));
                        envFile = "";
                        try {
                            for (_d = __values(Object.keys(flattenedParsedVars)), _e = _d.next(); !_e.done; _e = _d.next()) {
                                key = _e.value;
                                envFile += "".concat(key, "=").concat(flattenedParsedVars[key], "\n");
                            }
                        }
                        catch (e_3_1) { e_3 = { error: e_3_1 }; }
                        finally {
                            try {
                                if (_e && !_e.done && (_j = _d.return)) _j.call(_d);
                            }
                            finally { if (e_3) throw e_3.error; }
                        }
                        console.log(envFile);
                        process.exit(0);
                    }
                    propertyPath = opt;
                    if (!propertyPath) {
                        console.error(logs.pleaseProvideEnvPropertyPath());
                        console.error(logs.seeAllEnvProperties());
                        process.exit(1);
                    }
                    envPropertyValue = env;
                    try {
                        for (_f = __values(propertyPath.split(".")), _g = _f.next(); !_g.done; _g = _f.next()) {
                            p = _g.value;
                            envPropertyValue = envPropertyValue[p];
                            if (envPropertyValue === undefined) {
                                console.error(logs.propertyNotFound(propertyPath));
                                console.error(logs.seeAllEnvProperties());
                                process.exit(1);
                            }
                        }
                    }
                    catch (e_4_1) { e_4 = { error: e_4_1 }; }
                    finally {
                        try {
                            if (_g && !_g.done && (_k = _f.return)) _k.call(_f);
                        }
                        finally { if (e_4) throw e_4.error; }
                    }
                    if (typeof envPropertyValue !== "string" &&
                        typeof envPropertyValue !== "boolean" &&
                        typeof envPropertyValue !== "number") {
                        console.error(logs.cantReturnNonString(propertyPath, typeof envPropertyValue));
                        console.error(envPropertyValue);
                        process.exit(1);
                    }
                    if (flags === "--not") {
                        isBoolean = "".concat(envPropertyValue) === "true" || "".concat(envPropertyValue) === "false";
                        if (isBoolean) {
                            console.log(!("".concat(envPropertyValue) === "true"));
                            process.exit(0);
                        }
                        else {
                            console.error(logs.cantNegateNonBoolean(envPropertyValue));
                            process.exit(1);
                        }
                    }
                    console.log(envPropertyValue);
                    return [2];
            }
        });
    });
}
function flattenObj(obj, parent, res) {
    if (parent === void 0) { parent = undefined; }
    if (res === void 0) { res = {}; }
    for (var key in obj) {
        var propName = parent ? parent + "." + key : key;
        if (typeof obj[key] == "object") {
            flattenObj(obj[key], propName, res);
        }
        else {
            res[propName] = obj[key];
        }
    }
    return res;
}
main();
//# sourceMappingURL=bin.js.map